-- define FontOptions
function GetFontOptions()
    local container = Settings.CreateControlTextContainer()
    container:Add("morpheus_cz.ttf", "Morpheus (cz)")
    container:Add("frizquadratatt_cz.ttf", "Friz Quadrata TT (cz)")
    container:Add("quicksand.ttf", "Quicksand")
    container:Add("caveat.ttf", "Caveat")
    return container:GetData()
end

function CzechQuestsAddon:InitializeSettings()
    local category, layout = Settings.RegisterVerticalLayoutCategory("CzechQuests")

    -- Add options for quests
    layout:AddInitializer(CreateSettingsListSectionHeaderInitializer("Questy"))
    CzechQuestsAddon:AddQuestOptions(category, layout)

    -- Add options for speech
    layout:AddInitializer(CreateSettingsListSectionHeaderInitializer("Projevy (zatím ve vývoji)"))
    CzechQuestsAddon:AddSpeechOptions(category, layout)

    -- Add options for speech
    layout:AddInitializer(CreateSettingsListSectionHeaderInitializer("Ostatní"))
    CzechQuestsAddon:AddOthersOptions(category, layout)

    -- Store it into Addon options
    Settings.RegisterAddOnCategory(category)
end